;*************************************************************** 
;* Feladat:
;* Ksztsen assembly programot, ami beolvassa D port rtkt s a fels ngy bitjt villogtatjuk 
;az E port als ngy bitjn 1 Hz-el
;* Kzben a mikrovezrl OC0 lbt villogtatjuk 30 Hz-el

;* Feltltjk az SRAM els hrom cmt konstans rtkekkel s 
;a D port 0-s bitjn lv gomb lenyomsnak hatsra
;* az els cmen lv rtket rajuk ki a C portra ...
;a D port 1-es bitjn lv gomb lenyomsnak hatsra
;* a msodik cmen lv rtket rajuk ki a C portra ...
;a D port 2-es bitjn lv gomb lenyomsnak hatsra
;* a harmadik cmen lv rtket rajuk ki a C portra ...
;*************************************************************** 
;* 
;*  Kszitette: Fehr rpd
;*  Csoport:
;*  Dtum:
;* 
;***************************************************************
 
.include "m128def.inc"  		; ATmega128 defincis fjl
 
;*************************************************************** 
;* Konstansok 
;***************************************************************
.equ	LEDmask = 0x0F			;als ngy bit
.equ	byte_num=3
;*************************************************************** 
;* Vltozk
;*************************************************************** 
.def	mpr1 = R16				;  ltalnos felhasznls regiszterek
.def	mpr2 = R17
.def	mpr3 = R18
.def	tcnt = R19

; Adatszegmens (SRAM), a RAM kezdcme 0x100 (ATmega128)
.dseg
mem_space: .byte byte_num				; Memria terlet lefoglalsa
;*************************************************************** 
;* Makrk
;*************************************************************** 
.MACRO Timer0_Init ;mode, compvalue
		ldi		mpr1,@0		
		out		TCCR0,mpr1		
		ldi		mpr1,@1		
		out		OCR0,mpr1		
		in		mpr1,TIMSK
		ori		mpr1,1<<OCIE0	;Timer0 OC IT enabled
		out		TIMSK,mpr1
.ENDMACRO
;*************************************************************** 
;* Megszakts vektorok
;*************************************************************** 
.cseg 
.org 0x0000      				; Kdszegmens kezdcme

		jmp		init		; Reset vektor 
		jmp		dummy		; EXTINT0 Handler
		jmp		dummy		; EXTINT1 Handler
		jmp		dummy		; EXTINT2 Handler
		jmp		dummy		; EXTINT3 Handler
		jmp		dummy		; EXTINT4 Handler (INT gomb)
		jmp		dummy		; EXTINT5 Handler
		jmp		dummy		; EXTINT6 Handler
		jmp		dummy		; EXTINT7 Handler
		jmp		dummy		; Timer2 Compare Match Handler 
		jmp		dummy		; Timer2 Overflow Handler 
		jmp		dummy		; Timer1 Capture Event Handler 
		jmp		dummy		; Timer1 Compare Match A Handler 
		jmp		dummy		; Timer1 Compare Match B Handler 
		jmp		dummy		; Timer1 Overflow Handler 
		jmp		t0_oc_it	; Timer0 Compare Match Handler 
		jmp		dummy		; Timer0 Overflow Handler 
		jmp		dummy		; SPI Transfer Complete Handler 
		jmp		dummy		; USART0 RX Complete Handler 
		jmp		dummy		; USART0 Data Register Empty Hanlder 
		jmp		dummy		; USART0 TX Complete Handler 
		jmp		dummy		; ADC Conversion Complete Handler 
		jmp		dummy		; EEPROM Ready Hanlder 
		jmp		dummy		; Analog Comparator Handler 
		jmp		dummy		; Timer1 Compare Match C Handler 
		jmp		dummy		; Timer3 Capture Event Handler 
		jmp		dummy		; Timer3 Compare Match A Handler 
		jmp		dummy		; Timer3 Compare Match B Handler 
		jmp		dummy		; Timer3 Compare Match C Handler 
		jmp		dummy		; Timer3 Overflow Handler 
		jmp		dummy		; USART1 RX Complete Handler 
		jmp		dummy		; USART1 Data Register Empty Hanlder 
		jmp		dummy		; USART1 TX Complete Handler 
		jmp		dummy		; Two-wire Serial Interface Handler 
		jmp		dummy		; Store Program Memory Ready Handler 

;*****************************************************************************
;* Inicializls
;*****************************************************************************

;***** Stack inicializlsa *****

init:	ldi		mpr1,LOW(RAMEND)	; RAMEND = RAM vgcme
		out		SPL,mpr1			; (ld."m128def.inc") 
		ldi		mpr1,HIGH(RAMEND)
		out		SPH,mpr1

;*****************************************************************************
;* Fprogram
;*****************************************************************************	

main:

	    ldi		XL, low(mem_space)	;X regiszter feltltse 2 lpsben
	    ldi		XH, high(mem_space)
		ldi		mpr1,0x0F
		st		X,mpr1
		//
	    inc XL
		ldi		mpr1,0xF0
		st		X,mpr1
		//
		inc XL
		ldi		mpr1,0xFF
		st		X,mpr1


		ldi		mpr1,0x00
		out		DDRD,mpr1

		ldi		mpr1,LEDmask
		out		DDRE,mpr1

		ldi		mpr1,0x10
		out		DDRB,mpr1

		ldi		mpr1,0xFF
		out		DDRC,mpr1
								
		; 1024 prescaler, CTC mode (clear on compare match) OC0 disconnected
		; TCCR0: FOC0 WGM00 COM01 CM00 WGM01 CS02 CS01 CS00
		;         0    0    0     1     1     1    1    1
		; f = 8000000/(1024*128*2) = 30.52 Hz (32.76 ms)  1/30.52=0.032768 <-- ennyi msodpercenknt fog belefutni az interruptba
		//TIMER0_Init 0x1F,128
		ldi		mpr1,0x1f		
		out		TCCR0,mpr1		
		ldi		mpr1,255	
		out		OCR0,mpr1		
		in		mpr1,TIMSK
		ori		mpr1,1<<OCIE0	;Timer0 OC IT enabled
		out		TIMSK,mpr1

		ldi		tcnt,30		
		sei


loop:

		in mpr1, PIND		;D port rtknek beolvassa mpr1-be

		;***** 1. verzi *****
SWITCH1:
		cpi  	mpr1, 1		; sszehasonltja val-t 1-gyel
  		breq  	S_1_1    	; Ha mpr1 == 1, akkor elgazs S_1_1-re
  		cpi  	mpr1, 2		; sszehasonltja val-t 2-vel
		breq	S_1_2		; Ha mpr1 == 2, akkor elgazs S_1_2-re
		cpi		mpr1, 4		; sszehasonltja val-t 3-mal
		breq	S_1_3		; Ha mpr1 == 4, akkor elgazs S_1_3-re
							; Ha egyik sem, akkor default g

		rjmp	NEXT7		; Kiugrs a SWITCH-bl

S_1_1:						; 1-es g futtatsa
							
		ldi		XL, 0x01	;X regiszter feltltse 2 lpsben
	    ldi		XH, 0x00

		ld		mpr1,X		; sram-bl olvass
		out		PORTC,mpr1	; Kijelzem  rtkt

		rjmp	NEXT7		; Kiugrs a SWITCH-bl

S_1_2:						; 2-es g futtatsa
							
		ldi		XL, 0x01	;X regiszter feltltse 2 lpsben
	    ldi		XH, 0x01

		ld		mpr1,X		; sram-bl olvass
		out		PORTC,mpr1	; Kijelzem  rtkt

		rjmp	NEXT7		; Kiugrs a SWITCH-bl

S_1_3:						; 3-as g futtatsa	
							
		ldi		XL, 0x01	;X regiszter feltltse 2 lpsben
	    ldi		XH, 0x02

		ld		mpr1,X		; sram-bl olvass
		out		PORTC,mpr1	; Kijelzem  rtkt

		rjmp	NEXT7		; Kiugrs a SWITCH-bl

DFLT:						; Ha egyik sem, akkor default g
							
		ldi		mpr1,0x00	; sram-bl olvass
		out		PORTC,mpr1	; Kijelzem  rtkt

NEXT7:						; Folytats a tbbi programrsszel


	jmp		loop		; vgtelen hurok

;*****************************************************************************
;* Szubrutinok
;*****************************************************************************

;*****************************************************************************
;* Megszakts kezel rutinok
;*****************************************************************************
t0_oc_it:
		push	mpr1			;mpr1 veremtrba
		push	mpr2			;mpr2 veremtrba
		dec		tcnt			;tcnt cskkentse
		brne	exit_t0_it	

		in		mpr1,PINE
		ldi		mpr2,LEDmask
		eor		mpr1,mpr2
		in		mpr3, PIND
		swap	mpr3
		and		mpr1,mpr3

		out		PORTE,mpr1
		ldi		tcnt,30

exit_t0_it:
		pop		mpr2			;mpr2 kiolvassa veremtrbl
		pop		mpr1			;mpr1 kiolvassa veremtrbl
		reti					


dummy: reti
;*****************************************************************************
;* Adatok
;*****************************************************************************